/*
 * SM2 internal helpers
 *
 * Copyright (C) 2019 Chengdu Haiguang Integrated Circuit Design Co., Ltd.
 *
 * Author: Panyang Du <dupanyang@hygon.com>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 */
#ifndef _SM2_HELPER_
#define _SM2_HELPER_
#include <linux/types.h>

/**
 * SM2_key - SM2 key structure
 * @d           : SM2 private key byte stream
 * @q           : SM2 public key byte stream
 * @d_sz        : length in bytes of SM2 private key
 * @q_sz        : length in bytes of SM2 public key
 */
struct sm2_key {
	const u8 *d;
	const u8 *q;
	size_t d_sz;
	size_t q_sz;
};

int sm2_parse_pub_key(struct sm2_key *sm2_key, const void *key,
		      unsigned int key_len);

int sm2_parse_priv_key(struct sm2_key *sm2_key, const void *key,
		       unsigned int key_len);

#endif
